procedure OpCodeCB; assembler;
asm
    xor  ax, ax
    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]

    { Update tick counter }
    mov  bx, ax
    xor  cx, cx
    mov  cl, byte ptr oCyclesCB[bx]
    add  word ptr si[TICKCOUNT], cx

    shl  ax, 2
    mov  bx, offset @RLC_B
    add  ax, bx
    jmp  ax
  @RLC_B:
    jmp  @RLC_B_Func
    nop

  @RLC_C:
    jmp  @RLC_C_Func
    nop

  @RLC_D:
    jmp  @RLC_D_Func
    nop

  @RLC_E:
    jmp  @RLC_E_Func
    nop

  @RLC_H:
    jmp  @RLC_H_Func
    nop

  @RLC_L:
    jmp  @RLC_L_Func
    nop

  @RLC_xHL:
    jmp  @RLC_xHL_Func
    nop

  @RLC_A:
    jmp  @RLC_A_Func
    nop

  @RRC_B:
    jmp  @RRC_B_Func
    nop

  @RRC_C:
    jmp  @RRC_C_Func
    nop

  @RRC_D:
    jmp  @RRC_D_Func
    nop

  @RRC_E:
    jmp  @RRC_E_Func
    nop

  @RRC_H:
    jmp  @RRC_H_Func
    nop

  @RRC_L:
    jmp  @RRC_L_Func
    nop

  @RRC_xHL:
    jmp  @RRC_xHL_Func
    nop

  @RRC_A:
    jmp  @RRC_A_Func
    nop

  @RL_B:
    jmp  @RL_B_Func
    nop

  @RL_C:
    jmp  @RL_C_Func
    nop

  @RL_D:
    jmp  @RL_D_Func
    nop

  @RL_E:
    jmp  @RL_E_Func
    nop

  @RL_H:
    jmp  @RL_H_Func
    nop

  @RL_L:
    jmp  @RL_L_Func
    nop

  @RL_xHL:
    jmp  @RL_xHL_Func
    nop

  @RL_A:
    jmp  @RL_A_Func
    nop

  @RR_B:
    jmp  @RR_B_Func
    nop

  @RR_C:
    jmp  @RR_C_Func
    nop

  @RR_D:
    jmp  @RR_D_Func
    nop

  @RR_E:
    jmp  @RR_E_Func
    nop

  @RR_H:
    jmp  @RR_H_Func
    nop

  @RR_L:
    jmp  @RR_L_Func
    nop

  @RR_xHL:
    jmp  @RR_xHL_Func
    nop

  @RR_A:
    jmp  @RR_A_Func
    nop

  @SLA_B:
    jmp  @SLA_B_Func
    nop

  @SLA_C:
    jmp  @SLA_C_Func
    nop

  @SLA_D:
    jmp  @SLA_D_Func
    nop

  @SLA_E:
    jmp  @SLA_E_Func
    nop

  @SLA_H:
    jmp  @SLA_H_Func
    nop

  @SLA_L:
    jmp  @SLA_L_Func
    nop

  @SLA_xHL:
    jmp  @SLA_xHL_Func
    nop

  @SLA_A:
    jmp  @SLA_A_Func
    nop

  @SRA_B:
    jmp  @SRA_B_Func
    nop

  @SRA_C:
    jmp  @SRA_C_Func
    nop

  @SRA_D:
    jmp  @SRA_D_Func
    nop

  @SRA_E:
    jmp  @SRA_E_Func
    nop

  @SRA_H:
    jmp  @SRA_H_Func
    nop

  @SRA_L:
    jmp  @SRA_L_Func
    nop

  @SRA_xHL:
    jmp  @SRA_xHL_Func
    nop

  @SRA_A:
    jmp  @SRA_A_Func
    nop

  @SLL_B:
    jmp  @SLL_B_Func
    nop

  @SLL_C:
    jmp  @SLL_C_Func
    nop

  @SLL_D:
    jmp  @SLL_D_Func
    nop

  @SLL_E:
    jmp  @SLL_E_Func
    nop

  @SLL_H:
    jmp  @SLL_H_Func
    nop

  @SLL_L:
    jmp  @SLL_L_Func
    nop

  @SLL_xHL:
    jmp  @SLL_xHL_Func
    nop

  @SLL_A:
    jmp  @SLL_A_Func
    nop

  @SRL_B:
    jmp  @SRL_B_Func
    nop

  @SRL_C:
    jmp  @SRL_C_Func
    nop

  @SRL_D:
    jmp  @SRL_D_Func
    nop

  @SRL_E:
    jmp  @SRL_E_Func
    nop

  @SRL_H:
    jmp  @SRL_H_Func
    nop

  @SRL_L:
    jmp  @SRL_L_Func
    nop

  @SRL_xHL:
    jmp  @SRL_xHL_Func
    nop

  @SRL_A:
    jmp  @SRL_A_Func
    nop

  @BIT0_B:
    jmp  @BIT0_B_Func
    nop

  @BIT0_C:
    jmp  @BIT0_C_Func
    nop

  @BIT0_D:
    jmp  @BIT0_D_Func
    nop

  @BIT0_E:
    jmp  @BIT0_E_Func
    nop

  @BIT0_H:
    jmp  @BIT0_H_Func
    nop

  @BIT0_L:
    jmp  @BIT0_L_Func
    nop

  @BIT0_xHL:
    jmp  @BIT0_xHL_Func
    nop

  @BIT0_A:
    jmp  @BIT0_A_Func
    nop

  @BIT1_B:
    jmp  @BIT1_B_Func
    nop

  @BIT1_C:
    jmp  @BIT1_C_Func
    nop

  @BIT1_D:
    jmp  @BIT1_D_Func
    nop

  @BIT1_E:
    jmp  @BIT1_E_Func
    nop

  @BIT1_H:
    jmp  @BIT1_H_Func
    nop

  @BIT1_L:
    jmp  @BIT1_L_Func
    nop

  @BIT1_xHL:
    jmp  @BIT1_xHL_Func
    nop

  @BIT1_A:
    jmp  @BIT1_A_Func
    nop

  @BIT2_B:
    jmp  @BIT2_B_Func
    nop

  @BIT2_C:
    jmp  @BIT2_C_Func
    nop

  @BIT2_D:
    jmp  @BIT2_D_Func
    nop

  @BIT2_E:
    jmp  @BIT2_E_Func
    nop

  @BIT2_H:
    jmp  @BIT2_H_Func
    nop

  @BIT2_L:
    jmp  @BIT2_L_Func
    nop

  @BIT2_xHL:
    jmp  @BIT2_xHL_Func
    nop

  @BIT2_A:
    jmp  @BIT2_A_Func
    nop

  @BIT3_B:
    jmp  @BIT3_B_Func
    nop

  @BIT3_C:
    jmp  @BIT3_C_Func
    nop

  @BIT3_D:
    jmp  @BIT3_D_Func
    nop

  @BIT3_E:
    jmp  @BIT3_E_Func
    nop

  @BIT3_H:
    jmp  @BIT3_H_Func
    nop

  @BIT3_L:
    jmp  @BIT3_L_Func
    nop

  @BIT3_xHL:
    jmp  @BIT3_xHL_Func
    nop

  @BIT3_A:
    jmp  @BIT3_A_Func
    nop

  @BIT4_B:
    jmp  @BIT4_B_Func
    nop

  @BIT4_C:
    jmp  @BIT4_C_Func
    nop

  @BIT4_D:
    jmp  @BIT4_D_Func
    nop

  @BIT4_E:
    jmp  @BIT4_E_Func
    nop

  @BIT4_H:
    jmp  @BIT4_H_Func
    nop

  @BIT4_L:
    jmp  @BIT4_L_Func
    nop

  @BIT4_xHL:
    jmp  @BIT4_xHL_Func
    nop

  @BIT4_A:
    jmp  @BIT4_A_Func
    nop

  @BIT5_B:
    jmp  @BIT5_B_Func
    nop

  @BIT5_C:
    jmp  @BIT5_C_Func
    nop

  @BIT5_D:
    jmp  @BIT5_D_Func
    nop

  @BIT5_E:
    jmp  @BIT5_E_Func
    nop

  @BIT5_H:
    jmp  @BIT5_H_Func
    nop

  @BIT5_L:
    jmp  @BIT5_L_Func
    nop

  @BIT5_xHL:
    jmp  @BIT5_xHL_Func
    nop

  @BIT5_A:
    jmp  @BIT5_A_Func
    nop

  @BIT6_B:
    jmp  @BIT6_B_Func
    nop

  @BIT6_C:
    jmp  @BIT6_C_Func
    nop

  @BIT6_D:
    jmp  @BIT6_D_Func
    nop

  @BIT6_E:
    jmp  @BIT6_E_Func
    nop

  @BIT6_H:
    jmp  @BIT6_H_Func
    nop

  @BIT6_L:
    jmp  @BIT6_L_Func
    nop

  @BIT6_xHL:
    jmp  @BIT6_xHL_Func
    nop

  @BIT6_A:
    jmp  @BIT6_A_Func
    nop

  @BIT7_B:
    jmp  @BIT7_B_Func
    nop

  @BIT7_C:
    jmp  @BIT7_C_Func
    nop

  @BIT7_D:
    jmp  @BIT7_D_Func
    nop

  @BIT7_E:
    jmp  @BIT7_E_Func
    nop

  @BIT7_H:
    jmp  @BIT7_H_Func
    nop

  @BIT7_L:
    jmp  @BIT7_L_Func
    nop

  @BIT7_xHL:
    jmp  @BIT7_xHL_Func
    nop

  @BIT7_A:
    jmp  @BIT7_A_Func
    nop

  @RES0_B:
    jmp  @RES0_B_Func
    nop

  @RES0_C:
    jmp  @RES0_C_Func
    nop

  @RES0_D:
    jmp  @RES0_D_Func
    nop

  @RES0_E:
    jmp  @RES0_E_Func
    nop

  @RES0_H:
    jmp  @RES0_H_Func
    nop

  @RES0_L:
    jmp  @RES0_L_Func
    nop

  @RES0_xHL:
    jmp  @RES0_xHL_Func
    nop

  @RES0_A:
    jmp  @RES0_A_Func
    nop

  @RES1_B:
    jmp  @RES1_B_Func
    nop

  @RES1_C:
    jmp  @RES1_C_Func
    nop

  @RES1_D:
    jmp  @RES1_D_Func
    nop

  @RES1_E:
    jmp  @RES1_E_Func
    nop

  @RES1_H:
    jmp  @RES1_H_Func
    nop

  @RES1_L:
    jmp  @RES1_L_Func
    nop

  @RES1_xHL:
    jmp  @RES1_xHL_Func
    nop

  @RES1_A:
    jmp  @RES1_A_Func
    nop

  @RES2_B:
    jmp  @RES2_B_Func
    nop

  @RES2_C:
    jmp  @RES2_C_Func
    nop

  @RES2_D:
    jmp  @RES2_D_Func
    nop

  @RES2_E:
    jmp  @RES2_E_Func
    nop

  @RES2_H:
    jmp  @RES2_H_Func
    nop

  @RES2_L:
    jmp  @RES2_L_Func
    nop

  @RES2_xHL:
    jmp  @RES2_xHL_Func
    nop

  @RES2_A:
    jmp  @RES2_A_Func
    nop

  @RES3_B:
    jmp  @RES3_B_Func
    nop

  @RES3_C:
    jmp  @RES3_C_Func
    nop

  @RES3_D:
    jmp  @RES3_D_Func
    nop

  @RES3_E:
    jmp  @RES3_E_Func
    nop

  @RES3_H:
    jmp  @RES3_H_Func
    nop

  @RES3_L:
    jmp  @RES3_L_Func
    nop

  @RES3_xHL:
    jmp  @RES3_xHL_Func
    nop

  @RES3_A:
    jmp  @RES3_A_Func
    nop

  @RES4_B:
    jmp  @RES4_B_Func
    nop

  @RES4_C:
    jmp  @RES4_C_Func
    nop

  @RES4_D:
    jmp  @RES4_D_Func
    nop

  @RES4_E:
    jmp  @RES4_E_Func
    nop

  @RES4_H:
    jmp  @RES4_H_Func
    nop

  @RES4_L:
    jmp  @RES4_L_Func
    nop

  @RES4_xHL:
    jmp  @RES4_xHL_Func
    nop

  @RES4_A:
    jmp  @RES4_A_Func
    nop

  @RES5_B:
    jmp  @RES5_B_Func
    nop

  @RES5_C:
    jmp  @RES5_C_Func
    nop

  @RES5_D:
    jmp  @RES5_D_Func
    nop

  @RES5_E:
    jmp  @RES5_E_Func
    nop

  @RES5_H:
    jmp  @RES5_H_Func
    nop

  @RES5_L:
    jmp  @RES5_L_Func
    nop

  @RES5_xHL:
    jmp  @RES5_xHL_Func
    nop

  @RES5_A:
    jmp  @RES5_A_Func
    nop

  @RES6_B:
    jmp  @RES6_B_Func
    nop

  @RES6_C:
    jmp  @RES6_C_Func
    nop

  @RES6_D:
    jmp  @RES6_D_Func
    nop

  @RES6_E:
    jmp  @RES6_E_Func
    nop

  @RES6_H:
    jmp  @RES6_H_Func
    nop

  @RES6_L:
    jmp  @RES6_L_Func
    nop

  @RES6_xHL:
    jmp  @RES6_xHL_Func
    nop

  @RES6_A:
    jmp  @RES6_A_Func
    nop

  @RES7_B:
    jmp  @RES7_B_Func
    nop

  @RES7_C:
    jmp  @RES7_C_Func
    nop

  @RES7_D:
    jmp  @RES7_D_Func
    nop

  @RES7_E:
    jmp  @RES7_E_Func
    nop

  @RES7_H:
    jmp  @RES7_H_Func
    nop

  @RES7_L:
    jmp  @RES7_L_Func
    nop

  @RES7_xHL:
    jmp  @RES7_xHL_Func
    nop

  @RES7_A:
    jmp  @RES7_A_Func
    nop

  @SET0_B:
    jmp  @SET0_B_Func
    nop

  @SET0_C:
    jmp  @SET0_C_Func
    nop

  @SET0_D:
    jmp  @SET0_D_Func
    nop

  @SET0_E:
    jmp  @SET0_E_Func
    nop

  @SET0_H:
    jmp  @SET0_H_Func
    nop

  @SET0_L:
    jmp  @SET0_L_Func
    nop

  @SET0_xHL:
    jmp  @SET0_xHL_Func
    nop

  @SET0_A:
    jmp  @SET0_A_Func
    nop

  @SET1_B:
    jmp  @SET1_B_Func
    nop

  @SET1_C:
    jmp  @SET1_C_Func
    nop

  @SET1_D:
    jmp  @SET1_D_Func
    nop

  @SET1_E:
    jmp  @SET1_E_Func
    nop

  @SET1_H:
    jmp  @SET1_H_Func
    nop

  @SET1_L:
    jmp  @SET1_L_Func
    nop

  @SET1_xHL:
    jmp  @SET1_xHL_Func
    nop

  @SET1_A:
    jmp  @SET1_A_Func
    nop

  @SET2_B:
    jmp  @SET2_B_Func
    nop

  @SET2_C:
    jmp  @SET2_C_Func
    nop

  @SET2_D:
    jmp  @SET2_D_Func
    nop

  @SET2_E:
    jmp  @SET2_E_Func
    nop

  @SET2_H:
    jmp  @SET2_H_Func
    nop

  @SET2_L:
    jmp  @SET2_L_Func
    nop

  @SET2_xHL:
    jmp  @SET2_xHL_Func
    nop

  @SET2_A:
    jmp  @SET2_A_Func
    nop

  @SET3_B:
    jmp  @SET3_B_Func
    nop

  @SET3_C:
    jmp  @SET3_C_Func
    nop

  @SET3_D:
    jmp  @SET3_D_Func
    nop

  @SET3_E:
    jmp  @SET3_E_Func
    nop

  @SET3_H:
    jmp  @SET3_H_Func
    nop

  @SET3_L:
    jmp  @SET3_L_Func
    nop

  @SET3_xHL:
    jmp  @SET3_xHL_Func
    nop

  @SET3_A:
    jmp  @SET3_A_Func
    nop

  @SET4_B:
    jmp  @SET4_B_Func
    nop

  @SET4_C:
    jmp  @SET4_C_Func
    nop

  @SET4_D:
    jmp  @SET4_D_Func
    nop

  @SET4_E:
    jmp  @SET4_E_Func
    nop

  @SET4_H:
    jmp  @SET4_H_Func
    nop

  @SET4_L:
    jmp  @SET4_L_Func
    nop

  @SET4_xHL:
    jmp  @SET4_xHL_Func
    nop

  @SET4_A:
    jmp  @SET4_A_Func
    nop

  @SET5_B:
    jmp  @SET5_B_Func
    nop

  @SET5_C:
    jmp  @SET5_C_Func
    nop

  @SET5_D:
    jmp  @SET5_D_Func
    nop

  @SET5_E:
    jmp  @SET5_E_Func
    nop

  @SET5_H:
    jmp  @SET5_H_Func
    nop

  @SET5_L:
    jmp  @SET5_L_Func
    nop

  @SET5_xHL:
    jmp  @SET5_xHL_Func
    nop

  @SET5_A:
    jmp  @SET5_A_Func
    nop

  @SET6_B:
    jmp  @SET6_B_Func
    nop

  @SET6_C:
    jmp  @SET6_C_Func
    nop

  @SET6_D:
    jmp  @SET6_D_Func
    nop

  @SET6_E:
    jmp  @SET6_E_Func
    nop

  @SET6_H:
    jmp  @SET6_H_Func
    nop

  @SET6_L:
    jmp  @SET6_L_Func
    nop

  @SET6_xHL:
    jmp  @SET6_xHL_Func
    nop

  @SET6_A:
    jmp  @SET6_A_Func
    nop

  @SET7_B:
    jmp  @SET7_B_Func
    nop

  @SET7_C:
    jmp  @SET7_C_Func
    nop

  @SET7_D:
    jmp  @SET7_D_Func
    nop

  @SET7_E:
    jmp  @SET7_E_Func
    nop

  @SET7_H:
    jmp  @SET7_H_Func
    nop

  @SET7_L:
    jmp  @SET7_L_Func
    nop

  @SET7_xHL:
    jmp  @SET7_xHL_Func
    nop

  @SET7_A:
    jmp  @SET7_A_Func
    nop

  @RLC_B_Func:
    rol  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_C_Func:
    rol  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_D_Func:
    rol  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_E_Func:
    rol  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_H_Func:
    rol  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_L_Func:
    rol  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RLC_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    rol  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RLC_A_Func:
    rol  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_B_Func:
    ror  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_C_Func:
    ror  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_D_Func:
    ror  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_E_Func:
    ror  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_H_Func:
    ror  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_L_Func:
    ror  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RRC_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    ror  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RRC_A_Func:
    ror  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_B_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_C_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_D_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_E_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_H_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_L_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RL_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    ror  byte ptr si[FREG], 1
    rcl  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RL_A_Func:
    ror  byte ptr si[FREG], 1
    rcl  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_B_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_C_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_D_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_E_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_H_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_L_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @RR_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    ror  byte ptr si[FREG], 1
    rcr  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RR_A_Func:
    ror  byte ptr si[FREG], 1
    rcr  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SLA_B_Func:
    shl  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_C_Func:
    shl  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_D_Func:
    shl  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_E_Func:
    shl  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_H_Func:
    shl  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_L_Func:
    shl  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SLA_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    push bx
    shl  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    pop  bx
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SLA_A_Func:
    shl  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRA_B_Func:
    sar  byte ptr si[BREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_C_Func:
    sar  byte ptr si[CREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_D_Func:
    sar  byte ptr si[DREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_E_Func:
    sar  byte ptr si[EREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_H_Func:
    sar  byte ptr si[HREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_L_Func:
    sar  byte ptr si[LREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SRA_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    sar  dl,1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SRA_A_Func:
    sar  byte ptr si[AREG],1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_B_Func:
    stc
    rcl  byte ptr si[BREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_C_Func:
    stc
    rcl  byte ptr si[CREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_D_Func:
    stc
    rcl  byte ptr si[DREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_E_Func:
    stc
    rcl  byte ptr si[EREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_H_Func:
    stc
    rcl  byte ptr si[HREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_L_Func:
    stc
    rcl  byte ptr si[LREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SLL_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    stc
    rcl  dl,1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SLL_A_Func:
    stc
    rcl  byte ptr si[AREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @SRL_B_Func:
    shr  byte ptr si[BREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_C_Func:
    shr  byte ptr si[CREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_D_Func:
    shr  byte ptr si[DREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_E_Func:
    shr  byte ptr si[EREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_H_Func:
    shr  byte ptr si[HREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_L_Func:
    shr  byte ptr si[LREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @SRL_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    mov  dl, al
    push bx
    shr  dl, 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    pop  bx
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SRL_A_Func:
    shr  byte ptr si[AREG], 1
    lahf
    and  ah, C_FLAG
    mov  al, ah
    mov  ah,byte ptr si[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    and  byte ptr si[FREG], $FF xor (Z_FLAG or C_FLAG or S_FLAG or P_FLAG or N_FLAG or H_FLAG)
    or   byte ptr si[FREG],ah
    jmp  @Exit

  @BIT0_B_Func:
    test byte ptr si[BREG], 00000001b
    jnz  @BIT0_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_BEnd
  @BIT0_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_BEnd:
    jmp  @Exit

  @BIT0_C_Func:
    test byte ptr si[CREG], 00000001b
    jnz  @BIT0_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_CEnd
  @BIT0_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_CEnd:
    jmp  @Exit

  @BIT0_D_Func:
    test byte ptr si[DREG], 00000001b
    jnz  @BIT0_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_DEnd
  @BIT0_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_DEnd:
    jmp  @Exit

  @BIT0_E_Func:
    test byte ptr si[EREG], 00000001b
    jnz  @BIT0_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_EEnd
  @BIT0_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_EEnd:
    jmp  @Exit

  @BIT0_H_Func:
    test byte ptr si[HREG], 00000001b
    jnz  @BIT0_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_HEnd
  @BIT0_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_HEnd:
    jmp  @Exit

  @BIT0_L_Func:
    test byte ptr si[LREG], 00000001b
    jnz  @BIT0_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_LEnd
  @BIT0_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_LEnd:
    jmp  @Exit

  @BIT0_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00000001b
    jnz  @BIT0_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_xHLEnd
  @BIT0_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_xHLEnd:
    jmp  @Exit

  @BIT0_A_Func:
    test byte ptr si[AREG], 00000001b
    jnz  @BIT0_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT0_AEnd
  @BIT0_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT0_AEnd:
    jmp  @Exit

  @BIT1_B_Func:
    test byte ptr si[BREG], 00000010b
    jnz  @BIT1_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_BEnd
  @BIT1_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_BEnd:
    jmp  @Exit

  @BIT1_C_Func:
    test byte ptr si[CREG], 00000010b
    jnz  @BIT1_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_CEnd
  @BIT1_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_CEnd:
    jmp  @Exit

  @BIT1_D_Func:
    test byte ptr si[DREG], 00000010b
    jnz  @BIT1_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_DEnd
  @BIT1_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_DEnd:
    jmp  @Exit

  @BIT1_E_Func:
    test byte ptr si[EREG], 00000010b
    jnz  @BIT1_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_EEnd
  @BIT1_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_EEnd:
    jmp  @Exit

  @BIT1_H_Func:
    test byte ptr si[HREG], 00000010b
    jnz  @BIT1_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_HEnd
  @BIT1_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_HEnd:
    jmp  @Exit

  @BIT1_L_Func:
    test byte ptr si[LREG], 00000010b
    jnz  @BIT1_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_LEnd
  @BIT1_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_LEnd:
    jmp  @Exit

  @BIT1_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00000010b
    jnz  @BIT1_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_xHLEnd
  @BIT1_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_xHLEnd:
    jmp  @Exit

  @BIT1_A_Func:
    test byte ptr si[AREG], 00000010b
    jnz  @BIT1_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT1_AEnd
  @BIT1_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT1_AEnd:
    jmp  @Exit

  @BIT2_B_Func:
    test byte ptr si[BREG], 00000100b
    jnz  @BIT2_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_BEnd
  @BIT2_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_BEnd:
    jmp  @Exit

  @BIT2_C_Func:
    test byte ptr si[CREG], 00000100b
    jnz  @BIT2_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_CEnd
  @BIT2_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_CEnd:
    jmp  @Exit

  @BIT2_D_Func:
    test byte ptr si[DREG], 00000100b
    jnz  @BIT2_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_DEnd
  @BIT2_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_DEnd:
    jmp  @Exit

  @BIT2_E_Func:
    test byte ptr si[EREG], 00000100b
    jnz  @BIT2_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_EEnd
  @BIT2_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_EEnd:
    jmp  @Exit

  @BIT2_H_Func:
    test byte ptr si[HREG], 00000100b
    jnz  @BIT2_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_HEnd
  @BIT2_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_HEnd:
    jmp  @Exit

  @BIT2_L_Func:
    test byte ptr si[LREG], 00000100b
    jnz  @BIT2_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_LEnd
  @BIT2_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_LEnd:
    jmp  @Exit

  @BIT2_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00000100b
    jnz  @BIT2_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_xHLEnd
  @BIT2_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_xHLEnd:
    jmp  @Exit

  @BIT2_A_Func:
    test byte ptr si[AREG], 00000100b
    jnz  @BIT2_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT2_AEnd
  @BIT2_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT2_AEnd:
    jmp  @Exit

  @BIT3_B_Func:
    test byte ptr si[BREG], 00001000b
    jnz  @BIT3_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_BEnd
  @BIT3_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_BEnd:
    jmp  @Exit

  @BIT3_C_Func:
    test byte ptr si[CREG], 00001000b
    jnz  @BIT3_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_CEnd
  @BIT3_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_CEnd:
    jmp  @Exit

  @BIT3_D_Func:
    test byte ptr si[DREG], 00001000b
    jnz  @BIT3_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_DEnd
  @BIT3_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_DEnd:
    jmp  @Exit

  @BIT3_E_Func:
    test byte ptr si[EREG], 00001000b
    jnz  @BIT3_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_EEnd
  @BIT3_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_EEnd:
    jmp  @Exit

  @BIT3_H_Func:
    test byte ptr si[HREG], 00001000b
    jnz  @BIT3_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_HEnd
  @BIT3_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_HEnd:
    jmp  @Exit

  @BIT3_L_Func:
    test byte ptr si[LREG], 00001000b
    jnz  @BIT3_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_LEnd
  @BIT3_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_LEnd:
    jmp  @Exit

  @BIT3_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00001000b
    jnz  @BIT3_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_xHLEnd
  @BIT3_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_xHLEnd:
    jmp  @Exit

  @BIT3_A_Func:
    test byte ptr si[AREG], 00001000b
    jnz  @BIT3_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT3_AEnd
  @BIT3_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT3_AEnd:
    jmp  @Exit

  @BIT4_B_Func:
    test byte ptr si[BREG], 00010000b
    jnz  @BIT4_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_BEnd
  @BIT4_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_BEnd:
    jmp  @Exit

  @BIT4_C_Func:
    test byte ptr si[CREG], 00010000b
    jnz  @BIT4_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_CEnd
  @BIT4_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_CEnd:
    jmp  @Exit

  @BIT4_D_Func:
    test byte ptr si[DREG], 00010000b
    jnz  @BIT4_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_DEnd
  @BIT4_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_DEnd:
    jmp  @Exit

  @BIT4_E_Func:
    test byte ptr si[EREG], 00010000b
    jnz  @BIT4_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_EEnd
  @BIT4_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_EEnd:
    jmp  @Exit

  @BIT4_H_Func:
    test byte ptr si[HREG], 00010000b
    jnz  @BIT4_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_HEnd
  @BIT4_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_HEnd:
    jmp  @Exit

  @BIT4_L_Func:
    test byte ptr si[LREG], 00010000b
    jnz  @BIT4_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_LEnd
  @BIT4_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_LEnd:
    jmp  @Exit

  @BIT4_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00010000b
    jnz  @BIT4_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_xHLEnd
  @BIT4_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_xHLEnd:
    jmp  @Exit

  @BIT4_A_Func:
    test byte ptr si[AREG], 00010000b
    jnz  @BIT4_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT4_AEnd
  @BIT4_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT4_AEnd:
    jmp  @Exit

  @BIT5_B_Func:
    test byte ptr si[BREG], 00100000b
    jnz  @BIT5_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_BEnd
  @BIT5_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_BEnd:
    jmp  @Exit

  @BIT5_C_Func:
    test byte ptr si[CREG], 00100000b
    jnz  @BIT5_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_CEnd
  @BIT5_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_CEnd:
    jmp  @Exit

  @BIT5_D_Func:
    test byte ptr si[DREG], 00100000b
    jnz  @BIT5_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_DEnd
  @BIT5_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_DEnd:
    jmp  @Exit

  @BIT5_E_Func:
    test byte ptr si[EREG], 00100000b
    jnz  @BIT5_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_EEnd
  @BIT5_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_EEnd:
    jmp  @Exit

  @BIT5_H_Func:
    test byte ptr si[HREG], 00100000b
    jnz  @BIT5_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_HEnd
  @BIT5_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_HEnd:
    jmp  @Exit

  @BIT5_L_Func:
    test byte ptr si[LREG], 00100000b
    jnz  @BIT5_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_LEnd
  @BIT5_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_LEnd:
    jmp  @Exit

  @BIT5_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 00100000b
    jnz  @BIT5_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_xHLEnd
  @BIT5_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_xHLEnd:
    jmp  @Exit

  @BIT5_A_Func:
    test byte ptr si[AREG], 00100000b
    jnz  @BIT5_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT5_AEnd
  @BIT5_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT5_AEnd:
    jmp  @Exit

  @BIT6_B_Func:
    test byte ptr si[BREG], 01000000b
    jnz  @BIT6_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_BEnd
  @BIT6_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_BEnd:
    jmp  @Exit

  @BIT6_C_Func:
    test byte ptr si[CREG], 01000000b
    jnz  @BIT6_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_CEnd
  @BIT6_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_CEnd:
    jmp  @Exit

  @BIT6_D_Func:
    test byte ptr si[DREG], 01000000b
    jnz  @BIT6_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_DEnd
  @BIT6_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_DEnd:
    jmp  @Exit

  @BIT6_E_Func:
    test byte ptr si[EREG], 01000000b
    jnz  @BIT6_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_EEnd
  @BIT6_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_EEnd:
    jmp  @Exit

  @BIT6_H_Func:
    test byte ptr si[HREG], 01000000b
    jnz  @BIT6_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_HEnd
  @BIT6_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_HEnd:
    jmp  @Exit

  @BIT6_L_Func:
    test byte ptr si[LREG], 01000000b
    jnz  @BIT6_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_LEnd
  @BIT6_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_LEnd:
    jmp  @Exit

  @BIT6_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 01000000b
    jnz  @BIT6_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_xHLEnd
  @BIT6_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_xHLEnd:
    jmp  @Exit

  @BIT6_A_Func:
    test byte ptr si[AREG], 01000000b
    jnz  @BIT6_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT6_AEnd
  @BIT6_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG
  @BIT6_AEnd:
    jmp  @Exit

  @BIT7_B_Func:
    test byte ptr si[BREG], 10000000b
    jnz  @BIT7_BBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_BEnd
  @BIT7_BBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_BEnd:
    jmp  @Exit

  @BIT7_C_Func:
    test byte ptr si[CREG], 10000000b
    jnz  @BIT7_CBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_CEnd
  @BIT7_CBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_CEnd:
    jmp  @Exit

  @BIT7_D_Func:
    test byte ptr si[DREG], 10000000b
    jnz  @BIT7_DBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_DEnd
  @BIT7_DBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_DEnd:
    jmp  @Exit

  @BIT7_E_Func:
    test byte ptr si[EREG], 10000000b
    jnz  @BIT7_EBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_EEnd
  @BIT7_EBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_EEnd:
    jmp  @Exit

  @BIT7_H_Func:
    test byte ptr si[HREG], 10000000b
    jnz  @BIT7_HBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_HEnd
  @BIT7_HBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_HEnd:
    jmp  @Exit

  @BIT7_L_Func:
    test byte ptr si[LREG], 10000000b
    jnz  @BIT7_LBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_LEnd
  @BIT7_LBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_LEnd:
    jmp  @Exit

  @BIT7_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    test al, 10000000b
    jnz  @BIT7_xHLBit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_xHLEnd
  @BIT7_xHLBit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_xHLEnd:
    jmp  @Exit

  @BIT7_A_Func:
    test byte ptr si[AREG], 10000000b
    jnz  @BIT7_ABit1
    and  byte ptr si[FREG], $FF xor (N_FLAG  or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or Z_FLAG
    jmp  @BIT7_AEnd
  @BIT7_ABit1:
    and  byte ptr si[FREG], $FF xor (Z_FLAG or N_FLAG or P_FLAG or S_FLAG)
    or   byte ptr si[FREG], H_FLAG or S_FLAG
  @BIT7_AEnd:
    jmp  @Exit

  @RES0_B_Func:
    and  byte ptr si[BREG], 11111110b
    jmp  @Exit

  @RES0_C_Func:
    and  byte ptr si[CREG], 11111110b
    jmp  @Exit

  @RES0_D_Func:
    and  byte ptr si[DREG], 11111110b
    jmp  @Exit

  @RES0_E_Func:
    and  byte ptr si[EREG], 11111110b
    jmp  @Exit

  @RES0_H_Func:
    and  byte ptr si[HREG], 11111110b
    jmp  @Exit

  @RES0_L_Func:
    and  byte ptr si[LREG], 11111110b
    jmp  @Exit

  @RES0_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11111110b
    call PutByte
    jmp  @Exit

  @RES0_A_Func:
    and  byte ptr si[AREG], 11111110b
    jmp  @Exit

  @RES1_B_Func:
    and  byte ptr si[BREG], 11111101b
    jmp  @Exit

  @RES1_C_Func:
    and  byte ptr si[CREG], 11111101b
    jmp  @Exit

  @RES1_D_Func:
    and  byte ptr si[DREG], 11111101b
    jmp  @Exit

  @RES1_E_Func:
    and  byte ptr si[EREG], 11111101b
    jmp  @Exit

  @RES1_H_Func:
    and  byte ptr si[HREG], 11111101b
    jmp  @Exit

  @RES1_L_Func:
    and  byte ptr si[LREG], 11111101b
    jmp  @Exit

  @RES1_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11111101b
    call PutByte
    jmp  @Exit

  @RES1_A_Func:
    and  byte ptr si[AREG], 11111101b
    jmp  @Exit

  @RES2_B_Func:
    and  byte ptr si[BREG], 11111011b
    jmp  @Exit

  @RES2_C_Func:
    and  byte ptr si[CREG], 11111011b
    jmp  @Exit

  @RES2_D_Func:
    and  byte ptr si[DREG], 11111011b
    jmp  @Exit

  @RES2_E_Func:
    and  byte ptr si[EREG], 11111011b
    jmp  @Exit

  @RES2_H_Func:
    and  byte ptr si[HREG], 11111011b
    jmp  @Exit

  @RES2_L_Func:
    and  byte ptr si[LREG], 11111011b
    jmp  @Exit

  @RES2_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11111011b
    call PutByte
    jmp  @Exit

  @RES2_A_Func:
    and  byte ptr si[AREG], 11111011b
    jmp  @Exit

  @RES3_B_Func:
    and  byte ptr si[BREG], 11110111b
    jmp  @Exit

  @RES3_C_Func:
    and  byte ptr si[CREG], 11110111b
    jmp  @Exit

  @RES3_D_Func:
    and  byte ptr si[DREG], 11110111b
    jmp  @Exit

  @RES3_E_Func:
    and  byte ptr si[EREG], 11110111b
    jmp  @Exit

  @RES3_H_Func:
    and  byte ptr si[HREG], 11110111b
    jmp  @Exit

  @RES3_L_Func:
    and  byte ptr si[LREG], 11110111b
    jmp  @Exit

  @RES3_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11110111b
    call PutByte
    jmp  @Exit

  @RES3_A_Func:
    and  byte ptr si[AREG], 11110111b
    jmp  @Exit

  @RES4_B_Func:
    and  byte ptr si[BREG], 11101111b
    jmp  @Exit

  @RES4_C_Func:
    and  byte ptr si[CREG], 11101111b
    jmp  @Exit

  @RES4_D_Func:
    and  byte ptr si[DREG], 11101111b
    jmp  @Exit

  @RES4_E_Func:
    and  byte ptr si[EREG], 11101111b
    jmp  @Exit

  @RES4_H_Func:
    and  byte ptr si[HREG], 11101111b
    jmp  @Exit

  @RES4_L_Func:
    and  byte ptr si[LREG], 11101111b
    jmp  @Exit

  @RES4_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11101111b
    call PutByte
    jmp  @Exit

  @RES4_A_Func:
    and  byte ptr si[AREG], 11101111b
    jmp  @Exit

  @RES5_B_Func:
    and  byte ptr si[BREG], 11011111b
    jmp  @Exit

  @RES5_C_Func:
    and  byte ptr si[CREG], 11011111b
    jmp  @Exit

  @RES5_D_Func:
    and  byte ptr si[DREG], 11011111b
    jmp  @Exit

  @RES5_E_Func:
    and  byte ptr si[EREG], 11011111b
    jmp  @Exit

  @RES5_H_Func:
    and  byte ptr si[HREG], 11011111b
    jmp  @Exit

  @RES5_L_Func:
    and  byte ptr si[LREG], 11011111b
    jmp  @Exit

  @RES5_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 11011111b
    call PutByte
    jmp  @Exit

  @RES5_A_Func:
    and  byte ptr si[AREG], 11011111b
    jmp  @Exit

  @RES6_B_Func:
    and  byte ptr si[BREG], 10111111b
    jmp  @Exit

  @RES6_C_Func:
    and  byte ptr si[CREG], 10111111b
    jmp  @Exit

  @RES6_D_Func:
    and  byte ptr si[DREG], 10111111b
    jmp  @Exit

  @RES6_E_Func:
    and  byte ptr si[EREG], 10111111b
    jmp  @Exit

  @RES6_H_Func:
    and  byte ptr si[HREG], 10111111b
    jmp  @Exit

  @RES6_L_Func:
    and  byte ptr si[LREG], 10111111b
    jmp  @Exit

  @RES6_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 10111111b
    call PutByte
    jmp  @Exit

  @RES6_A_Func:
    and  byte ptr si[AREG], 10111111b
    jmp  @Exit

  @RES7_B_Func:
    and  byte ptr si[BREG], 01111111b
    jmp  @Exit

  @RES7_C_Func:
    and  byte ptr si[CREG], 01111111b
    jmp  @Exit

  @RES7_D_Func:
    and  byte ptr si[DREG], 01111111b
    jmp  @Exit

  @RES7_E_Func:
    and  byte ptr si[EREG], 01111111b
    jmp  @Exit

  @RES7_H_Func:
    and  byte ptr si[HREG], 01111111b
    jmp  @Exit

  @RES7_L_Func:
    and  byte ptr si[LREG], 01111111b
    jmp  @Exit

  @RES7_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    and  al, 01111111b
    call PutByte
    jmp  @Exit

  @RES7_A_Func:
    and  byte ptr si[AREG], 01111111b
    jmp  @Exit

  @SET0_B_Func:
    or   byte ptr si[BREG], 00000001b
    jmp  @Exit

  @SET0_C_Func:
    or   byte ptr si[CREG], 00000001b
    jmp  @Exit

  @SET0_D_Func:
    or   byte ptr si[DREG], 00000001b
    jmp  @Exit

  @SET0_E_Func:
    or   byte ptr si[EREG], 00000001b
    jmp  @Exit

  @SET0_H_Func:
    or   byte ptr si[HREG], 00000001b
    jmp  @Exit

  @SET0_L_Func:
    or   byte ptr si[LREG], 00000001b
    jmp  @Exit

  @SET0_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00000001b
    call PutByte
    jmp  @Exit

  @SET0_A_Func:
    or   byte ptr si[AREG], 00000001b
    jmp  @Exit

  @SET1_B_Func:
    or   byte ptr si[BREG], 00000010b
    jmp  @Exit

  @SET1_C_Func:
    or   byte ptr si[CREG], 00000010b
    jmp  @Exit

  @SET1_D_Func:
    or   byte ptr si[DREG], 00000010b
    jmp  @Exit

  @SET1_E_Func:
    or   byte ptr si[EREG], 00000010b
    jmp  @Exit

  @SET1_H_Func:
    or   byte ptr si[HREG], 00000010b
    jmp  @Exit

  @SET1_L_Func:
    or   byte ptr si[LREG], 00000010b
    jmp  @Exit

  @SET1_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00000010b
    call PutByte
    jmp  @Exit

  @SET1_A_Func:
    or   byte ptr si[AREG], 00000010b
    jmp  @Exit

  @SET2_B_Func:
    or   byte ptr si[BREG], 00000100b
    jmp  @Exit

  @SET2_C_Func:
    or   byte ptr si[CREG], 00000100b
    jmp  @Exit

  @SET2_D_Func:
    or   byte ptr si[DREG], 00000100b
    jmp  @Exit

  @SET2_E_Func:
    or   byte ptr si[EREG], 00000100b
    jmp  @Exit

  @SET2_H_Func:
    or   byte ptr si[HREG], 00000100b
    jmp  @Exit

  @SET2_L_Func:
    or   byte ptr si[LREG], 00000100b
    jmp  @Exit

  @SET2_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00000100b
    call PutByte
    jmp  @Exit

  @SET2_A_Func:
    or   byte ptr si[AREG], 00000100b
    jmp  @Exit

  @SET3_B_Func:
    or   byte ptr si[BREG], 00001000b
    jmp  @Exit

  @SET3_C_Func:
    or   byte ptr si[CREG], 00001000b
    jmp  @Exit

  @SET3_D_Func:
    or   byte ptr si[DREG], 00001000b
    jmp  @Exit

  @SET3_E_Func:
    or   byte ptr si[EREG], 00001000b
    jmp  @Exit

  @SET3_H_Func:
    or   byte ptr si[HREG], 00001000b
    jmp  @Exit

  @SET3_L_Func:
    or   byte ptr si[LREG], 00001000b
    jmp  @Exit

  @SET3_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00001000b
    call PutByte
    jmp  @Exit

  @SET3_A_Func:
    or   byte ptr si[AREG], 00001000b
    jmp  @Exit

  @SET4_B_Func:
    or   byte ptr si[BREG], 00010000b
    jmp  @Exit

  @SET4_C_Func:
    or   byte ptr si[CREG], 00010000b
    jmp  @Exit

  @SET4_D_Func:
    or   byte ptr si[DREG], 00010000b
    jmp  @Exit

  @SET4_E_Func:
    or   byte ptr si[EREG], 00010000b
    jmp  @Exit

  @SET4_H_Func:
    or   byte ptr si[HREG], 00010000b
    jmp  @Exit

  @SET4_L_Func:
    or   byte ptr si[LREG], 00010000b
    jmp  @Exit

  @SET4_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00010000b
    call PutByte
    jmp  @Exit

  @SET4_A_Func:
    or   byte ptr si[AREG], 00010000b
    jmp  @Exit

  @SET5_B_Func:
    or   byte ptr si[BREG], 00100000b
    jmp  @Exit

  @SET5_C_Func:
    or   byte ptr si[CREG], 00100000b
    jmp  @Exit

  @SET5_D_Func:
    or   byte ptr si[DREG], 00100000b
    jmp  @Exit

  @SET5_E_Func:
    or   byte ptr si[EREG], 00100000b
    jmp  @Exit

  @SET5_H_Func:
    or   byte ptr si[HREG], 00100000b
    jmp  @Exit

  @SET5_L_Func:
    or   byte ptr si[LREG], 00100000b
    jmp  @Exit

  @SET5_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 00100000b
    call PutByte
    jmp  @Exit

  @SET5_A_Func:
    or   byte ptr si[AREG], 00100000b
    jmp  @Exit

  @SET6_B_Func:
    or   byte ptr si[BREG], 01000000b
    jmp  @Exit

  @SET6_C_Func:
    or   byte ptr si[CREG], 01000000b
    jmp  @Exit

  @SET6_D_Func:
    or   byte ptr si[DREG], 01000000b
    jmp  @Exit

  @SET6_E_Func:
    or   byte ptr si[EREG], 01000000b
    jmp  @Exit

  @SET6_H_Func:
    or   byte ptr si[HREG], 01000000b
    jmp  @Exit

  @SET6_L_Func:
    or   byte ptr si[LREG], 01000000b
    jmp  @Exit

  @SET6_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 01000000b
    call PutByte
    jmp  @Exit

  @SET6_A_Func:
    or   byte ptr si[AREG], 01000000b
    jmp  @Exit

  @SET7_B_Func:
    or   byte ptr si[BREG], 10000000b
    jmp  @Exit

  @SET7_C_Func:
    or   byte ptr si[CREG], 10000000b
    jmp  @Exit

  @SET7_D_Func:
    or   byte ptr si[DREG], 10000000b
    jmp  @Exit

  @SET7_E_Func:
    or   byte ptr si[EREG], 10000000b
    jmp  @Exit

  @SET7_H_Func:
    or   byte ptr si[HREG], 10000000b
    jmp  @Exit

  @SET7_L_Func:
    or   byte ptr si[LREG], 10000000b
    jmp  @Exit

  @SET7_xHL_Func:
    mov  bx, word ptr si[HLREG]
    call GetByte
    or   al, 10000000b
    call PutByte
    jmp  @Exit

  @SET7_A_Func:
    or   byte ptr si[AREG], 10000000b
    jmp  @Exit

  @Exit:
end;
