unit uTRS80;

interface


uses bas,crt,dos,kbd,MZio,Uz80,z80das,fenst;



procedure TRS80_out(adr,eing:word);
function  TRS80_in(eing:word):byte;
function  TRS80_read(addr:word):byte;
procedure TRS80_write(addr,eing:word);
procedure TRS80_Int;
procedure start_TRS80;



implementation

const VGG_ROM :word = $1E00;


procedure TRS80SAVECHART(name:string);

var i:word;
    k:file of byte;

begin
      assign(k,name+'.P');
      rewrite(k);

      for i:=$4009 to r_word(@speicher^[16406])+1
      do
        write(k,speicher^[i]);

      close(k);

end;


procedure TRS80LoadCart(name:string);
var
  oSnap: File of byte;
  I,l: word;
  nByte: Byte;

begin

    Assign(oSnap,Name);
    Reset(oSnap);


    i:=$4009;

    while not eof(oSnap)
    do
      begin
           Read(osnap,speicher^[i]);
           inc(i);
      end;


    Close(oSnap);

end;

(* ------------------------------ *)




procedure select_P(ext:string);
begin
     init_text;
     restore_keyb;
     dateiname:=windir('','*.'+ext);
     neuer_tast_int;
     init_mode_13;
     directvideo:=false;
     loesche_tasten;
end;

procedure refresh_trs_crt;forward;

procedure TRS80_out(adr,eing:word);
begin

end;



function TRS80_in(eing:word):byte;
var z:word;
    x:byte;
   te:word;
begin
     x:=0;

     trs80_in:=x;
   
end;



function  TRS80_read(addr:word):byte;
var   v:byte;
begin
      v:=speicher^[addr];

      if (addr >= $3800) and (addr <= $38ff)
      then
       begin
        v:=0;
        if tastatur <> []
        then
         begin

           if test_key(KALT) = 1
           then
               begin
                    if test_key(Kf8) = 1 then  aZ80Regs^.PC.W := $0000;
                    if test_key(KESC) = 1 then  exit_run:=1;
               end;

           if lo(addr) shr 0 = 1
           then
              begin
                   (* if test_key(K0) = 1 then v:=v or 1; *)
                   if test_key(KA) = 1 then v:=v or 2;
                   if test_key(KB) = 1 then v:=v or 4;
                   if test_key(KC) = 1 then v:=v or 8;
                   if test_key(KD) = 1 then v:=v or 16;
                   if test_key(KE) = 1 then v:=v or 32;
                   if test_key(KF) = 1 then v:=v or 64;
                   if test_key(KG) = 1 then v:=v or 128;
              end;

           if lo(addr) shr 1 = 1
           then
              begin
                   if test_key(KH) = 1 then v:=v or 1;
                   if test_key(KI) = 1 then v:=v or 2;
                   if test_key(KJ) = 1 then v:=v or 4;
                   if test_key(KK) = 1 then v:=v or 8;
                   if test_key(KL) = 1 then v:=v or 16;
                   if test_key(KM) = 1 then v:=v or 32;
                   if test_key(KN) = 1 then v:=v or 64;
                   if test_key(KO) = 1 then v:=v or 128;
              end;

           if lo(addr) shr 2 = 1
           then
              begin
                   if test_key(KP) = 1 then v:=v or 1;
                   if test_key(KQ) = 1 then v:=v or 2;
                   if test_key(KR) = 1 then v:=v or 4;
                   if test_key(KS) = 1 then v:=v or 8;
                   if test_key(KT) = 1 then v:=v or 16;
                   if test_key(KU) = 1 then v:=v or 32;
                   if test_key(KV) = 1 then v:=v or 64;
                   if test_key(KW) = 1 then v:=v or 128;
              end;

            if lo(addr) shr 3 = 1
           then
              begin
                   if test_key(KX) = 1 then v:=v or 1;
                   if test_key(KY) = 1 then v:=v or 2;
                   if test_key(KZ) = 1 then v:=v or 4;
                   if test_key(KF2) = 1 then v:=v or 8;
                   if test_key(KF1) = 1 then v:=v or 16;
                   if test_key(KF3) = 1 then v:=v or 32;
                   if test_key(KTilde) = 1 then v:=v or 64;
                   if test_key(KEqual) = 1 then v:=v or 128;
              end;

           if lo(addr) shr 4 = 1
           then
              begin
                   if test_key(K0) = 1 then v:=v or 1;
                   if test_key(K1) = 1 then v:=v or 2;
                   if test_key(K2) = 1 then v:=v or 4;
                   if test_key(K3) = 1 then v:=v or 8;
                   if test_key(K4) = 1 then v:=v or 16;
                   if test_key(K5) = 1 then v:=v or 32;
                   if test_key(K6) = 1 then v:=v or 64;
                   if test_key(K7) = 1 then v:=v or 128;
              end;


           if lo(addr) shr 5 = 1
           then
              begin
                   if test_key(K8) = 1 then v:=v or 1;
                   if test_key(K9) = 1 then v:=v or 2;
                   if test_key(Kcolon) = 1 then v:=v or 4;
                   if test_key(KQuote) = 1 then v:=v or 8;
                   if test_key(KComma) = 1 then v:=v or 16;
                   if test_key(KMinus) = 1 then v:=v or 32;
                   if test_key(KPeriod) = 1 then v:=v or 64;
                   if test_key(KSlash) = 1 then v:=v or 128;
              end;

            if lo(addr) shr 6 = 1
           then
              begin
                   if test_key(KEnter) = 1 then v:=v or 1;
                   (* if test_key(Kclr) = 1 then v:=v or 2; *)
                   if test_key(KEND) = 1 then v:=v or 4;
                   if test_key(Kup) = 1 then v:=v or 8;
                   if test_key(Kdn) = 1 then v:=v or 16;
                   if test_key(Klf) = 1 then v:=v or 32;
                   if test_key(KRT) = 1 then v:=v or 64;
                   if test_key(KSpace) = 1 then v:=v or 128;
              end;

              if lo(addr) shr 7 = 1
           then
              begin
                   if test_key(KlShift) = 1 then v:=v or 1;
                   if test_key(KAlt) = 1 then v:=v or 2;
                   if test_key(KPgup) = 1 then v:=v or 4;
                   if test_key(KPgdn) = 1 then v:=v or 8;
                   if test_key(Kins) = 1 then v:=v or 16;
                   if test_key(Kdel) = 1 then v:=v or 32;
                   if test_key(Kctrl) = 1 then v:=v or 64;
                   (* if test_key(KALTgr) = 1 then v:=v or 128; *)
              end;
           end;
         end;

      trs80_read:=v;
end;



const  trans_video:array[0..1] of array [0..255] of byte =
       (
           (
		$00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0a,$0b,$0c,$0d,$0e,$0f,
		$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1a,$1b,$1c,$1d,$1e,$1f,
		$20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2a,$2b,$2c,$2d,$2e,$2f,
		$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3a,$3b,$3c,$3d,$3e,$3f,
		$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f,
		$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f,
		$60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6a,$6b,$6c,$6d,$6e,$6f,
		$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7a,$7b,$7c,$7d,$7e,$7f,
		$80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,
		$90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a,$9b,$9c,$9d,$9e,$9f,
		$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,
		$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf,
		$c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf,
		$d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df,
		$e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef,
		$f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff
           ),
	   (
		$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f,
		$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f,
                $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2a,$2b,$2c,$2d,$2e,$2f,
                $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3a,$3b,$3c,$3d,$3e,$3f,
		$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f,
                $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f,
		$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f,
                $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f,
                $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,
                $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a,$9b,$9c,$9d,$9e,$9f,
                $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,
                $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf,
                $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f,
                $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a,$9b,$9c,$9d,$9e,$9f,
                $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,
                $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf
           )
        );




procedure TRS80_screen(ad,i:word);

var
    k,x,y:byte;
    Zeichen_matrix:pointer;
    v,h:byte;

begin
     y:=(ad-$3C00) div 64;
     x:=(1+ad-$3c00) - y*64;

     mem[voffs:(7+x-1) shl 1+(5+y-1)*160]:=trans_video[1][i];
end;



procedure refresh_TRS_crt;
var ad,i:word;

begin
       ad:=r_word(@speicher^[$400c]);

       (*
       for i:=ad to ad+792
          do
            TRS80_screen(ad);
       *)

end;




procedure TRS80_write(addr,eing:word);
var ad:word;
begin

         if addr >= $37f0  (* ROM MOD I -- MOD II *)
                then
                    speicher^[addr]:=eing;

         if (addr >= $3C00) and (addr <=$3FFF)
         then
             trs80_screen(addr,eing);

end;

(* ------------------------------ *)





procedure TRS80_Int;
var i,ad:word;
    k,x,y:byte;



begin


(* aProcs[1].nPendingIRQ := $000000FF;
 aProcs[1].nPendingIRQ := $000000D7;*)  (* RST 10H       *)


end;


procedure Pre_init;

begin
    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aZ80Regs^.SP.W := $FF00;
    aZ80Regs^.PC.W := $0000;

end;

procedure load_TRS80_system;
 begin

             fillchar(speicher^[0],65535,$ff);
             Pre_init;

             loadrom(akt_dir+'\TRS80.rom',0,@speicher^[0]);

             (*
             init_mode_13;
             *)

             aProcs[1].oGetByteFunc := TRS80_read;
             aProcs[1].oPutByteFunc := TRS80_write;
             aProcs[1].oOutByteFunc := TRS80_out;
             aProcs[1].oInByteFunc  := TRS80_in;
             aProcs[1].oInterruptFunc := TRS80_INT;
             aProcs[1].oMemory := speicher;


             aProcs[1].nNMIInt := $66;

             aZ80Regs^.nMaxROM := $37FF;
             aZ80Regs^.nMaxRAM := $FFFF;
             aZ80Regs^.nTickMach:=69888;

       end;








procedure start_TRS80;
var i:word;
begin
               writeln('INIT KEYB');
               neuer_tast_int;

               textbackground(0);
               clrscr;

               textcolor(yellow);
               textbackground(lightblue);

               load_TRS80_system;

               repeat until tastatur = [];
               tastaturspeicher:=[];
               loesche_tasten;

               directvideo:=true;

               exit_run:=0;
               repeat
                    Evalinstr(1);

                    if test_key(kalt) = 1
                    then
                       begin

                           if test_key(kF1) = 1 then
                             begin

                               restore_keyb;
                               textmode(co80);

                               help('TRS80.HLP');

                               neuer_tast_int;

                               (*
                               init_mode_13;
                               *)

                               refresh_TRS_crt;

                               directvideo:=false;
                               loesche_tasten;

                             end;

                            if test_key(KF11) = 1
                            then
                              begin

                                   select_p('p');

                                   refresh_TRS_crt;
                                   
                                   if dateiname <> 'ESCAPE'
                                   then
                                       TRS80LoadCart(dateiname);

                                   tastatur:=[];
                              end;

                       end;


               until kesc in tastatur;;

               restore_keyb;
               init_text;


end;





begin

end.