unit fenst;


(* 1997,1998,25.OKT *)

interface


uses dos,crt,bas;


type win_scr = array [0..8000] of byte;
     var win_screen:^win_scr;
         win_screen_buff:^win_scr;
         win_alt_x,
         win_alt_y:byte;

type  winpuffer =array[0..0] of  byte;


var   dest_farbe:word;

      alt_win_dir_path:string;  (* AUSGANGSPATH der Windirbox *)

type  win     =  object


      puffern :^winpuffer;
      pufferb :^winpuffer;

      laenge   : word;

      aktx,      (* Aktuelle Position im Fenster *)
      akty,

      xalt,
      yalt,

      wx,        (* Fenster position *)
      wy,
      wxx,
      wyy    :byte;

      farbe ,
      vfarbe :byte;
              

              procedure fenster(xx,yy,x1,y2:integer;headline:string);

              
              procedure select;
              procedure deSelect;
              procedure save;
              procedure restaurate;

              procedure close;

              procedure balkeninit(x,y:byte);
              procedure tbalkeninit(x,y:byte;text:string);
              procedure balken(wert,max:real);
              procedure balkenclose;



      end;


procedure init;
procedure game;

function  wpop(x,y,w:byte;titel,uebergabe:string):byte;
procedure rs_status(sn:word);
procedure rs_st;

function windir(path,namea:string):string;
procedure t_wart(zeit:byte);
procedure save_screen;
procedure restore_screen;

implementation


procedure init;

var i:word;

begin


      window(1,1,80,25);
      textcolor(7);
      textbackground(red);

      clrscr;
      for i:=1 to 2000
         do
           mem[video:i shl 1]:=(177);

      textcolor(yellow);

      gotoxy(1,1);

end;


procedure save_screen;
begin
     win_alt_x:=wherex;
     win_alt_y:=wherey;
     getmem(win_screen_buff,8000);
     win_screen:=ptr(video,0);
     move(win_screen^,win_screen_buff^,8000);
end;

procedure restore_screen;
begin
     move(win_screen_buff^,win_screen^,8000);

     freemem(win_screen_buff,8000);
     gotoxy(win_alt_x,win_alt_y);
end;


procedure win.fenster(xx,yy,x1,y2:integer;headline:string);

(*  headline:='XYZ'  Fenster ohne Schatten *)
(*  headline:='#xyz' Fenster mit  Schatten *)

var lae :integer;
var i  :integer;


const strich: string = '';

begin

      wx:=xx+1; wy:=yy+1;  wxx:=x1-1;  wyy:=y2-1;

      laenge:=(wxx-wx+5) shl 1 * (wyy-wy + 4);


      getmem(puffern,laenge);
      getmem(pufferb,laenge);


      for i:=0 to y2-yy+3
            do
      move(ptr(voffs,(yy-1+i)*160+(xx-1) shl 1)^,puffern^[i*(x1-xx+2)*2],(x1-xx+2) shl 1);

      


      

      window(1,1,80,24);

      lae:=abs(x1-xx);

      gotoxy(xx,yy);writeln(left(strich,lae));
      gotoxy(xx,y2);writeln(left(strich,lae));
      gotoxy(xx+lae div 2-length(headline) div 2,yy);
      for i:=yy to y2
	do
	  begin
	       gotoxy(xx,i);writeln(#186);
	       gotoxy(x1,i);writeln(#186);
	       if headline[1]='#'
		 then
		    if x1 < 80
		       then
			  setvattr(x1+1,i+1,6);
	  end;

      if headline[1]='#'
	 then
	    if  y2 < 24
	      then
	        for i:=xx+1 to x1
		 do
		   setvattr(i,y2+1,6);

       if headline[1] = '#'
	 then
	     delete(headline,1,1);

       if headline <> ''
       then
	  begin
	       gotoxy(xx+lae div 2-length(headline) div 2,yy);
	       writeln('[',headline,']');
	  end;


      gotoxy(xx,yy); writeln(#201);
      gotoxy(x1,yy); writeln(#187);
      gotoxy(xx,y2); writeln(#200);
      gotoxy(x1,y2); writeln(#188);

      window(xx+1,yy+1,x1-1,y2-1);

      clrscr;

      win.save;

end;




procedure win.save;      (* Schatten werden nicht gesichert !!! *)
var i:byte;

begin

     farbe:=textattr;
     for i:=0 to wyy-wy+2
            do
                move(ptr(voffs,(wy-2+i)*160+(wx-2) shl 1)^,pufferb^[i*(wxx-wx+4)*2],(wxx-wx+3) shl 1);
end;


procedure win.restaurate;
var i:byte;
begin
     for i:=0 to wyy-wy+2
            do
                move(pufferb^[i*(wxx-wx+4)*2],ptr(voffs,(wy-2+i)*160+(wx-2) shl 1)^,(wxx-wx+3) shl 1);
     textattr:=farbe;
end;

procedure win.select;

begin
      window(wx,wy,wxx,wyy);
      win.restaurate;
      gotoxy(aktx,akty);
end;


procedure win.deSelect;
begin
     win.save;
     aktx:=wherex;
     akty:=wherey;
end;


procedure win.close;

var i:byte;

begin

      for i:=0 to wyy-wy+3  (* Alten Kontext laden *)
            do
                move(puffern^[i*(wxx-wx+4)*2],ptr(voffs,(wy-2+i)*160+(wx-2) shl 1)^,(wxx-wx+4) shl 1);

     freemem(puffern,laenge);
     freemem(pufferb,laenge);

     window(1,1,80,24);
     gotoxy(xalt,yalt);
end;

PROCEDURE win.Tbalkeninit(x,y:byte;text:string);
begin
      textcolor(white);
      textbackground(red);
      win.fenster(x,y,x+63,y+2,'#'+text);
      win.deselect;

end;

PROCEDURE win.balkeninit(x,y:byte);
begin
      textcolor(white);
      textbackground(red);
      win.fenster(x,y,x+63,y+2,'#');
      win.deselect;

end;

PROCEDURE win.balken(wert,max:real);

var i:byte;
begin
      csr_off;
      win.select;

      gotoxy(1,1);

      for i:=1 to trunc(wert/max * 60 )
        do
          begin
               write(#219);
          end;

      for i:=trunc(wert/max * 60 ) to 60
        do
          begin
               write(#176);
          end;


      win.deselect;
      csr_on;
end;

procedure win.balkenclose;
begin
      win.close;
end;

function mkey:integer;
var reg: registers;                (* Maustasten abfragen *)
begin

     if mouse
      then
         begin
             mkey:=0;  reg.ax:= $03; intr($33,reg);
						(* key = 1 : taste = links *)
             mkey:=reg.bl;                               (* key = 2 : taste = rechts *)
         end;
						(* key = 3 : beide tasten *)
end;


function wpop(x,y,w:byte;titel,uebergabe:string):byte;

                                                      (* x,y Position
                                                         L   :auswahlpunkt *)
var zahl,
    max,
    i,p,z:byte;
    wkey :char;
    fe   :win;

    s_key:string[40];
    s_kx:array[1..20] of byte;

begin
     csr_off;
     max:=0;  p:=1; wkey:=' ';   wpop:=zero;
     unstring(uebergabe,';');

     S_key:='';  for i:=1 to 20 do begin s_kx[i]:=0; s_key:=s_key+#254 ;end;

     for i:=1 to ausgabe.zahl
        do
         begin

          s_kx[i]:=pos('&',ausgabe.str[i]);  (* KEY-TASTEN FILTERN *)
          if s_kx[i] > 0
          then
             begin
              s_key[i]:=upcase(ausgabe.str[i][s_kx[i]+1]);
              delete(ausgabe.str[i],s_kx[i],1)
             end;
         end;



     for i:=1 to ausgabe.zahl
        do
         if length(ausgabe.str[i]) > max
                then
                     max:=length(ausgabe.str[i]);

     textcolor(14);
     textbackground(1);

     fe.fenster(x,y,x+3+max,y+1+ausgabe.zahl,titel);
     fe.select;

     textcolor(7);

     p:=w;

     if p > ausgabe.zahl
                        then p:=ausgabe.zahl;
     mouseon;
     mset((x+2)*8,(y)*8);

     repeat


          for i:=1 to ausgabe.zahl
          do
          begin
               gotoxy(1,i);
               write(' ',ausgabe.str[i]);

               if s_kx[i] > 0
               then
                  begin
                       textcolor(yellow);
                       gotoxy(s_kx[i]+1,i);
                       write(s_key[i]);
                       textcolor(7);
                  end;

          end;

          
          reversevideo;
          gotoxy(2,p);
          write(copy(ausgabe.str[p]+'                                    ',1,max),#13);

          if s_kx[p] > 0
               then
                  begin
                       textcolor(yellow);
                       gotoxy(s_kx[p]+1,p);
                       write(s_key[p]);
                       textcolor(7);
                  end;

          repeat

          until (keypressed or (key > 0));



          if key = 0 then
            begin
                wkey:=upcase(readkey);
                if wkey = #0
                then
                    case upcase(readkey)
                    of
                    'H':wkey:=#200;
                    'P':wkey:=#202;
                    else
                    wkey:=#240;
                end;
            end
          else

             case key
             of
               1:begin
                       if (mousey div 8 - y + 1 >= 0)  and (mousey div 8 - y + 1 <= ausgabe.zahl)
                         then
                           if (mousex div 8 > x+1) and (mousex div 8 < x+max+2)
                            then
                               begin
                                    p:=mousey div 8 - y+1;
                                    wkey:=#13;
                               end;
                 end;

              3:wkey:=#27;

          end;

          

          textcolor(7);
          textbackground(1);
          gotoxy(2,p);
          write(copy(ausgabe.str[p]+'                            ',1,max),#13);


          if wkey = #200
              then
                 if p > 1
                     then dec(p);

          if wkey = #202
                  then
                      if p < ausgabe.zahl
                              then
                                   inc(p);

          if pos(wkey,s_key) > 0
            then
               begin
                   p:=pos(wkey,s_key);
                   wkey:=#13;
               end;


     until(wkey in [#13,#27]);
     if wkey = #13
       then
          begin
              reverseVideo;
              gotoxy(2,p);
              write(copy(ausgabe.str[p]+'                            ',1,max),#13);
              normVideo;
              wpop:=p;
          end;

     mouseoff;
     fe.close;
     csr_on;
end;


procedure rs_status(sn:word);
var x:word;

const anz:array [0..2] of string[8] =  ('keine','gerade','ungerade');
      stat:array[0..1] of string[12] = ('Gesetzt','Nichtgesetzt');
begin
      
      writeln(nl,'   Basis Adresse :',hex(sn,3));
      writeln('   Empfangs-Halteregister :',hex(port[sn],2));
      x:=port[sn+3];
      port[sn+3]:=port[sn+3] or 128;
      write('   Bautrate :',115200/(port[sn]+256*port[sn+1]):5:0,' Baud :');
      port[sn+3]:=x;
      write(port[sn+3] and 3 + 5,' bit :',1 + port[sn+3] shr 2 and 1,' Stopbit(s) :',anz[port[sn+3] shr 3 and 3 ],' Paritt');

      writeln(nl,'     Modem: DTR: ',stat[port[sn+4] and 1],' RTS: ',stat[port[sn+4] shr 1 and 1],
      ' CTS: ',stat[port[sn+6] shr 4 and 1],nl,'            DSR: ',stat[port[sn+6] shr 5 and 1]
      ,' RI: ',stat[port[sn+6] shr 6 and 1],' DCD: ',stat[port[sn+6] shr 7 and 1]);

end;

procedure rs_st;
var   fe:win;

begin
      fe.fenster(3,3,74,17,'#Serielle Schnittstellen');
      repeat
            gotoxy(1,1);
            if com1 > 0 then
                          rs_status(com1);
            if com2 > 0 then
                          rs_status(com2);
      until keypressed;

      fe.close;
end;

function windir(path,namea:string):string;


type return =
     record
	   zahl    : BYTE;
	   str     : array[1..40]  of string;
     end;

var ausgabe : return;

    feld :array[1..128] of string[12];
    fattr:array[1..128] of byte;

    fenster :win;

    eing    :searchrec;


    i,x,
      y,
      k,
      v,w,
      startfeld,
      xgesamt,
      xofs,
      zahl  :byte;
      taste :char;

      fertig:boolean;


      puffer_feld:string;


procedure unstring( eingang,seperator:string);
var i: byte;
begin
       I:=0;
       if pos(seperator,eingang) > 0
       then
	   repeat
		   inc(i);
		   ausgabe.str[i]:=left(eingang,pos(seperator,eingang)-1);

		   if ausgabe.str[i] = ''
		      then dec(i);

		   delete(eingang,1,pos(seperator,eingang));

	   until (pos(seperator,eingang) = 0);

	   inc(i);
	   ausgabe.str[i]:=eingang;
	   ausgabe.zahl:=i;
end;



begin
      getdir(0,path);
      alt_win_dir_path:=path;


      chdir(path);
      getdir(0,path);

      if path[0]=#3
                  then path:=path[1]+path[2];

      textbackground(blue);


      fenster.fenster(8,5,74,20,'#DIR :'+copy(path+'\'+namea,1,40)+'..');
      fenster.select;




      unstring(namea,';');

      fertig:=true;     (* Dir einlesen *)

      repeat


        if fertig=true
        then
          begin

           clrscr;

           i:=1;
           eing.name:='*.*';

           findfirst(path+'\*.*',directory,eing);

           while doserror = 0
            do
                begin

                      feld[i]:=left(eing.name+'             ',12);;
                      fattr[i]:=eing.attr;





                      if eing.attr and directory = directory
                          then
                            inc(i);

                      findnext(eing);

                end;



            startfeld:=i;


            for k:=1 to ausgabe.zahl
            do
             BEGIN
              eing.name:=ausgabe.str[k];
              findfirst(path+'\'+ausgabe.str[k],anyfile,eing);

              while doserror = 0
              do
                begin

                      if eing.attr and directory <> directory
                          then
                            begin

                              (* Sort durch einfgen *)

                              feld[i]:=left('zzzzzzzzzzzzzzzzzzzzzzzzzzz',12);
                              puffer_feld:=left(eing.name+'             ',12);
                              inc(i);


                              v:=startfeld;  (* Startfeld zum Sort *)

                              repeat
                                   inc(v);
                              until copy(Puffer_feld,1,1) < copy(feld[v-1],1,1);
                              dec(v);

                              for w:=i downto v
                              do
                                begin
                                     feld[w]:=feld[w-1];
                                     fattr[w]:=fattr[w-1];
                                end;

                              feld[v]:=puffer_feld;
                              fattr[v]:=eing.attr;


                            end;

                      

                      findnext(eing);
                end;
              end;

              



                zahl:=i-1;

                gotoxy(1,1);
                for i:=1 to i-1

                do

                  if i < 70

                  then
                      begin
                           if fattr[i] and directory = directory
                           then
                               textcolor(14)
                               else
                                textcolor(green);

                                write(feld[i]+' ');
            end;

            fertig:=false;

          end;

          


      x:=1;  xofs:=0;

      xgesamt:=x;

      repeat

            gotoxy((x-((x-1) div 5)*5) * 13 - 12,(x-1) div 5 + 1);

                   reversevideo;
                   write(feld[xgesamt]);

                   textbackground(blue);
                   if fattr[xgesamt] and directory = directory
                    then
                        textcolor(14)
                    else
                        textcolor(green);
                 

            taste:=readkey;

            gotoxy((x-((x-1) div 5)*5) * 13 - 12,(x-1) div 5 + 1);
            write(feld[xgesamt]);


                 case taste of

                 #75 : if x > 0       then dec(x);
                 #77 : if xgesamt < zahl    then inc(x);
                 #72 : if x > 5       then dec(x,5);
                 #80 : if x < zahl- 4 then inc(x,5);
                 end;


            if (x > 69) and (xgesamt < zahl)
               then
                  begin
                       x:=69;
                       inc(xofs);

                       gotoxy(1,1);

                       for i:=1 to 69
                       do
                       begin
                            if fattr[i+xofs] and directory = directory
                              then
                                textcolor(14)
                               else
                                textcolor(green);

                              write(feld[i+xofs]+' ');
                       end;
                  end;


            if (x < 1) and (xofs > 0 )
               then
                  begin
                       x:=1;
                       dec(xofs);

                       gotoxy(1,1);

                       for i:=1 to 69
                       do
                       begin
                            if fattr[i+xofs] and directory = directory
                              then
                                textcolor(14)
                              else
                                textcolor(green);

                              write(feld[i+xofs]+' ');
                       end;
                  end;

            if x < 1  then x:=1;
            if x > 69 then x:=69;

            xgesamt:=x+xofs;

            if xgesamt >= zahl
                           then
                               xgesamt:=zahl;


      until(taste in [#13,#27]);

      
      {$I-}

      if taste=#13
            then
                if (fattr[xgesamt] and directory) = directory
                           then
                               begin
                                    if pos('..',feld[xgesamt]) > 0
                                    then  feld[xgesamt]:='..';
                                    if pos('. ',feld[xgesamt]) > 0
                                    then  feld[xgesamt]:='.';

                                    chdir(feld[xgesamt]);


                                    


                                    getdir(0,path);
                                    
                                    if path[0]=#3
                                         then
                                             path:=path[1]+path[2];

                                    fenster.close;

                                    fenster.fenster(8,5,74,20,'#DIR:'+copy(path+'\'+namea,1,40)+'..');
                                    fenster.select;

                                    fertig:=true;
                                    taste:=' ';
                               end;

      {$i+}

      until(taste in [#13,#27]);

      if taste = #13
                then windir:=feld[xgesamt]
                else windir:='ESCAPE';

      fenster.close;

end;



procedure game;

var x,y,ty,tx,zx,zy,steine,i,txx,tyy,
     ax,ay,ny,nx,pz :integer;
var zug     :boolean;
var zeichen :char;
    fe:win;

procedure wait;                        (* warten bis keine Maustaste gedr. *)
begin
     if maus
	     then begin
		      repeat
		      until (Key = 0);
		  end;
end;

function zugtest:boolean;
var test:integer;

begin

      test:= (abs(ax - nx) div 2) + abs(ay - ny);

      if ((test = 2) and ((ax = nx) or (ay = ny)))
	    then
		 zugtest:=true
	    else
		 zugtest:=false;
end;


begin

       i:=0;
       if maus = false
	 then
	  begin
	       tx:=11;
	       ty:=11;
	       pz:=dchar(tx,ty);
	  end;

     textcolor(7);
     textbackground(red);
     fe.fenster(5,3,33,15,'#Solitr');
     textcolor(14);
     csr_off;
	clrscr;

     zug:=false;    ax:=0; ay:=0; nx:=0 ;ny:=0;   steine:=44;
     gotoxy(1,1);
     writeln ('         ͻ'       )  ;
     writeln ('             '       )  ;
     writeln ('             '       )  ;
     writeln ('   ͼ    ͻ' )  ;
     writeln ('             ' )  ;
     writeln ('             ' )  ;
     writeln ('             ' )  ;
     writeln ('   ͻ    ͼ' )  ;
     writeln ('             '       )  ;
     writeln ('             '       )  ;
     write   ('         ͼ'       )  ;
     mouseon;

	repeat

	      tx:=1+mousex div 8;
	      ty:=1+mousey div 8;

	      if ((key = 1) and (dchar(tx,ty) = 236) and (zug = false))
		   then
		       begin
			    zug:=true;
			    ax:=tx;
			    ay:=ty;
			    wait;
		       end;


	      if ((key = 1) and (dchar(tx,ty) = 249) and (zug = true))
		   then
		       begin
			    nx:=tx;
			    ny:=ty;
			    zx:=ax+(nx-ax) div 2;
			    zy:=ay+(ny-ay) div 2;

			    if ((zugtest = true) and (dchar(zx,zy)=236))
			       then
				   begin
					setch(nx,ny,236);
					setch(ax,ay,249);
					setch(zx,zy,249);

					zug:=false;
					steine:= steine - 1;
					wait;
				   end
			       else
				   zug:=false;
		       end;

	until (keypressed) or (key > 1);
	mouseoff;
        csr_on;
        fe.close;
end;

procedure t_wart(zeit:byte);

var    BIOSzeit	   :longint absolute $0040:$006c;
       t0,t        :longint;
       fe          :win;
       ze          :char;
begin
      t0:=trunc(bioszeit/5);
      fe.tbalkeninit(5,21,'Taste drcken');
      repeat
        t:=trunc(bioszeit/5)-t0;
        fe.balken(t,zeit);
      until (keypressed or (t > zeit)) or (key = 2);
      fe.balkenclose;
      if keypressed
      then
         ze:=readkey;
end;


begin
     dest_farbe:=red;
end.