unit unascom1;

interface


uses bas,crt,dos,kbd,MZio,Uz80,z80das,fenst;



procedure nascom1_out(adr,eing:word);
function  nascom1_in(eing:word):byte;
function  nascom1_read(addr:word):byte;
procedure nascom1_write(addr,eing:word);
procedure nascom1_Int;
procedure start_nascom1;


(*
0000-07ff :monitor
0800-0bff :Display
0c00-0fff :arbeitsbereich
1000-dfff :memory
e000-ffff :Basic

*)

implementation

const VGG_ROM :word = $1E00;


procedure nascom1SAVECHART(name:string);

var i:word;
    k:file of byte;

begin
      assign(k,name+'.P');
      rewrite(k);

      for i:=$4009 to r_word(@speicher^[16406])+1
      do
        write(k,speicher^[i]);

      close(k);

end;


procedure nascom1LoadCart(name:string);
var
  oSnap: File of byte;
  I,l: word;
  nByte: Byte;

begin

    Assign(oSnap,Name);
    Reset(oSnap);

    Close(oSnap);

end;

(* ------------------------------ *)




procedure select_P(ext:string);
begin
     init_text;
     restore_keyb;
     dateiname:=windir('','*.'+ext);
     neuer_tast_int;
     init_mode_13;
     directvideo:=false;
     loesche_tasten;
end;

procedure nascom1_out(adr,eing:word);
begin
end;



function nascom1_in(eing:word):byte;
var z:word;
    x:byte;
   te:word;
begin

     x:=255;

     x:=random(255);
     nascom1_in:=x;

end;



function  nascom1_read(addr:word):byte;
var   v:byte;
begin

      v:=speicher^[addr];
      nascom1_read:=v;
end;




procedure nascom1_screen(ad,i:word);

var
    k,x,y:byte;
    Zeichen_matrix:pointer;
    v,h:byte;

begin


     y:=(ad-$0800) div 64;
     x:=(1+ad-$0800) - y*64;

     y:=y+5;x:=x+7;

     mem[voffs:  (x-1) shl 1+(y-1)*160]:=i;
     mem[voffs:1+(x-1) shl 1+(y-1)*160]:=blue or green shl 4;

end;





procedure nascom1_write(addr,eing:word);
var ad:word;
begin

         if (addr >= $800) and (addr <= $e000)
                then
                    speicher^[addr]:=eing;

         if (addr >= $0800) and (addr <= $0bff)
         then
             nascom1_screen(addr,eing);

end;


procedure refresh_nascom1_crt;
var ad,i:word;

begin
      for i:=$0800 to $0bff
      do
         nascom1_write(i,speicher^[i]);
end;
(* ------------------------------ *)





procedure nascom1_Int;
var i,ad:word;
    k,x,y:byte;



begin


(* aProcs[1].nPendingIRQ := $000000FF;
 aProcs[1].nPendingIRQ := $000000D7;*)  (* RST 10H       *)

end;


procedure Pre_init;

begin
    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aZ80Regs^.SP.W := $FF00;
    aZ80Regs^.PC.W := $0000;

end;

procedure load_nascom1_system;
 begin

             fillchar(speicher^[0],65535,$00);
             Pre_init;

             loadrom(akt_dir+'\nassys.rom',0,@speicher^[0]);

             move(speicher^[0800],speicher^[$E000],8*1024);

             aProcs[1].oGetByteFunc := nascom1_read;
             aProcs[1].oPutByteFunc := nascom1_write;
             aProcs[1].oOutByteFunc := nascom1_out;
             aProcs[1].oInByteFunc  := nascom1_in;
             aProcs[1].oInterruptFunc := nascom1_INT;
             aProcs[1].oMemory := speicher;


             aProcs[1].nNMIInt := $66;

             aZ80Regs^.nMaxROM := $37FF;
             aZ80Regs^.nMaxRAM := $FFFF;
             aZ80Regs^.nTickMach:=69888;

       end;








procedure start_nascom1;
var i:word;
begin
               writeln('INIT KEYB');
               neuer_tast_int;

               clrscr;

               textcolor(yellow);
               textbackground(lightblue);

               load_nascom1_system;

               tastaturspeicher:=[];
               loesche_tasten;

               directvideo:=true;

               refresh_nascom1_crt;
               exit_run:=0;
               repeat
                    Evalinstr(1);

                    gotoxy(1,1); write(hex(aZ80Regs^.PC.W,4));
                    if test_key(kalt) = 1
                    then
                       begin

                           if test_key(kF1) = 1 then
                             begin

                               restore_keyb;
                               textmode(co80);

                               help('nascom1.HLP');

                               neuer_tast_int;

                               (*
                               init_mode_13;
                               *)


                               directvideo:=false;
                               loesche_tasten;

                             end;


                       end;


               until kesc in tastatur;;

               restore_keyb;
               init_text;


end;





begin

end.